
import java.lang.*;
import java.util.*;

/** 
   A state class that supplies a general implementation of successors() 
   function for any traversable state space.
*/


public abstract class TraversableState implements State, Traversable {


/**
   Return successors using methods in Traversable interface.
*/
   public ArrayList<Successor> successors() { 

       ArrayList<Successor> successorList = new ArrayList<Successor>();

       ArrayList<String> opList = validOperators();

       for (String op : opList)
          successorList.add(
            new Successor(applyOperator(op), op, costOf(op)) );  
     
       return successorList;
   }

}
